' $INCLUDE: 'SYNGATE1.BAS'


TYPE SHIPPICKStruct
	LayCardHeaderStructure AS LayoutCardHeaderStruct
	PRODUCTStruct AS LayoutCardDescStruct
	CUSTIDStruct AS LayoutCardDescStruct
	CONTROLStruct AS LayoutCardDescStruct
	LOCATIONStruct AS LayoutCardDescStruct
	QTYTOSHIPStruct AS LayoutCardDescStruct
	STATUSStruct AS LayoutCardDescStruct
	CONTINUEStruct AS LayoutCardDescStruct
	CANCELStruct AS LayoutCardDescStruct
	ORDEREDQTYStruct AS LayoutCardDescStruct
	PARTIALSHIPOKStruct AS LayoutCardDescStruct
	SHIPPINGLINKStruct AS LayoutCardDescStruct
	LeftArrowStruct AS LayoutCardDescStruct
	RightArrowStruct AS LayoutCardDescStruct
	CardCondData AS STRING*2
	CardBackData AS STRING*298
	PRODUCT AS STRING*31
	CUSTID AS STRING*15
	CONTROL AS STRING*15
	LOCATION AS STRING*15
	QTYTOSHIP AS DOUBLE
	ORDEREDQTY AS DOUBLE
	STATUS AS STRING*1
	PARTIALSHIPOK AS STRING*1
	SHIPPINGLINK AS STRING*88
END TYPE

TYPE SHIPCARDStruct
	LayCardHeaderStructure AS LayoutCardHeaderStruct
	SHIPNAMEStruct AS LayoutCardDescStruct
	SHIPADDRESSStruct AS LayoutCardDescStruct
	SHIPCOMPANYStruct AS LayoutCardDescStruct
	SHIPCITYStruct AS LayoutCardDescStruct
	SHIPSTATEStruct AS LayoutCardDescStruct
	SHIPZIPStruct AS LayoutCardDescStruct
	SHIPAUTHORIZEDStruct AS LayoutCardDescStruct
	SHIPHOWPAYStruct AS LayoutCardDescStruct
	SHIPPOStruct AS LayoutCardDescStruct
	SHIPMMStruct AS LayoutCardDescStruct
	SHIPDAYStruct AS LayoutCardDescStruct
	SHIPYEARStruct AS LayoutCardDescStruct
	SHIPCLIENTStruct AS LayoutCardDescStruct
	CONTINUEStruct AS LayoutCardDescStruct
	CANCELStruct AS LayoutCardDescStruct
	PRODUCTNAMEStruct AS LayoutCardDescStruct
	QTYStruct AS LayoutCardDescStruct
	SHIPBYStruct AS LayoutCardDescStruct
	CUSTOMERIDStruct AS LayoutCardDescStruct
	SHIPTYPEStruct AS LayoutCardDescStruct
	PRODUCTSHIPPEDStruct AS LayoutCardDescStruct
	SHIPPEDQTYStruct AS LayoutCardDescStruct
	LeftArrowStruct AS LayoutCardDescStruct
	RightArrowStruct AS LayoutCardDescStruct
	CardCondData AS STRING*2
	CardBackData AS STRING*1931
	SHIPNAME AS STRING*30
	SHIPADDRESS AS STRING*34
	SHIPCOMPANY AS STRING*30
	SHIPCITY AS STRING*22
	SHIPSTATE AS STRING*5
	SHIPZIP AS STRING*13
	SHIPAUTHORIZED AS STRING*10
	SHIPBY AS STRING*21
	SHIPMM AS INTEGER
	SHIPDAY AS INTEGER
	SHIPYEAR AS INTEGER
	PRODUCTNAME AS STRING*32
	SHIPPO AS STRING*26
	CUSTOMERID AS STRING*21
	SHIPHOWPAY AS STRING*1
	QTY AS DOUBLE
	SHIPTYPE AS STRING*1
	SHIPCLIENT AS STRING*88
	PRODUCTSHIPPED AS STRING*32
	SHIPPEDQTY AS DOUBLE
END TYPE

TYPE sortlistStruct
	LayCardHeaderStructure AS LayoutCardHeaderStruct
	sortlistStruct AS LayoutCardDescStruct
	CardCondData AS STRING*2
	sortlistPblock AS LayoutCardPblockStruct
	sortlist AS STRING*320
END TYPE

TYPE SHIPLISTStruct
	LayCardHeaderStructure AS LayoutCardHeaderStruct
	SHIPPICKLISTStruct AS LayoutCardDescStruct
	CONTINUEStruct AS LayoutCardDescStruct
	CANCELStruct AS LayoutCardDescStruct
	CARDNUMBERStruct AS LayoutCardDescStruct
	CardCondData AS STRING*2
	CardBackData AS STRING*105
	SHIPPICKLISTPblock AS LayoutCardPblockStruct
	SHIPPICKLIST AS STRING*29200
	CARDNUMBERPblock AS LayoutCardPblockStruct
	CARDNUMBER AS STRING*1600
END TYPE


' --------------- BlackBoxes used by the Program ---------------

' STRLNGTH


DECLARE SUB GETTEXTOBJECTLENGTH ALIAS "GET_TEXT_OBJECT_LENGTH" (SEG p1$, SEG p2, BYVAL LT)




SUB SHIPPING (lt) STATIC


IF First.Run.Through <> 0 THEN GOTO Begin.Program ELSE First.Run.Through = 1


' ------------------------ Include Files ------------------------

' $INCLUDE: 'E:\RELEASE\SHIP.COD'

image.file.name$ = "E:\RELEASE\SHIP.IMG" + CHR$(0)

' $INCLUDE: 'E:\RELEASE\SHIP.RSC'




	CALL do.clear.card (VARSEG(SHIPPICK), VARPTR(SHIPPICK))
	CALL do.clear.card (VARSEG(SHIPCARD), VARPTR(SHIPCARD))
	CALL do.clear.card (VARSEG(sortlist), VARPTR(sortlist))
	CALL do.clear.card (VARSEG(SHIPLIST), VARPTR(SHIPLIST))


Begin.Program:

	CALL do.clear.card (VARSEG (SHIPPICK), VARPTR (SHIPPICK))

	GOSUB SHIPSTUFF

	IF (LISTBUTTON.ObjectType <> CHR$(1)) OR (LISTBUTTON.ObjectData1 <> &H0080) OR (UCASE$(LISTBUTTON.CardName) <> UCASE$(SHIPLIST.LayCardHeaderStructure.CardName)) AND (LISTBUTTON.ObjectType <> CHR$(1)) OR (_
		LISTBUTTON.ObjectData1 <> &H0170) OR (UCASE$(LISTBUTTON.CardName) <> UCASE$(SHIPPICK.LayCardHeaderStructure.CardName)) THEN

		CALL do.clear.card (VARSEG (SHIPCARD), VARPTR (SHIPCARD))
		' SHIP CARD

		CALL open.card.file (2, VARSEG (SHIPINPUT), VARPTR (SHIPINPUT), text.string1$, VARSEG (SHIPCARD), VARPTR (SHIPCARD), OPENSHIPRESULT)
		' SHIPINPUT

		GOSUB SEARCHFORPO

	END IF

	CALL close.card.file (VARSEG (SHIPPINGPICK), VARPTR (SHIPPINGPICK), CLOSESHIPPICK)
	' SHIPPINGPICK

	CALL close.card.file (VARSEG (SHIPINPUT), VARPTR (SHIPINPUT), CLOSESHIPRESULT)
	' SHIPINPUT


EXIT SUB


SHIPSTUFF:

	CALL do.clear.card (VARSEG (sortlist), VARPTR (sortlist))
	' SORT LIST

	CALL do.clear.card (VARSEG (SHIPLIST), VARPTR (SHIPLIST))

	CALL SetListString (sortlist.sortlistPblock.PblockTopOff,1,"STATUS" + CHR$(0))
	' STATUS

	CALL SetListString (sortlist.sortlistPblock.PblockTopOff,2,"PRODUCT" + CHR$(0))
	' PRODUCT

	CALL SetListString (sortlist.sortlistPblock.PblockTopOff,3,"CUST ID" + CHR$(0))
	' CUST ID

	CALL SetListString (sortlist.sortlistPblock.PblockTopOff,4,"CONTROL#" + CHR$(0))
	' CONTROL#

	CALL SetListString (sortlist.sortlistPblock.PblockTopOff,5,"LOCATION" + CHR$(0))
	' LOCATION

	CURRENTSHIPLISTITEM = 1
	' CLEAR ITEM

	CALL do.clear.card (VARSEG (SHIPPICK), VARPTR (SHIPPICK))

	CALL open.card.file (1, VARSEG (SHIPPINGPICK), VARPTR (SHIPPINGPICK), text.string2$, VARSEG (SHIPPICK), VARPTR (SHIPPICK), OPENSHIPPICK)
	' SHIPPINGPICK

	CALL get.cardfile.info (VARSEG (SHIPPINGPICK), VARPTR (SHIPPINGPICK), TOTALSHIPPICKCARDS, CURRENTSHIPPICKCARD)
	' SHIP PICK

	CALL move.file.ptr (DummyVariable&, CURRENTSHIPPICKCARD, VARSEG (SHIPPINGPICK), VARPTR (SHIPPINGPICK), 3)
	' FIRST CARD

	WHILE CURRENTSHIPPICKCARD <= TOTALSHIPPICKCARDS


		CALL get.current.card (VARSEG (SHIPPINGPICK), VARPTR (SHIPPINGPICK), OPENPICKRESULT)

		IF ASC(SHIPPICK.STATUS) <> 5 THEN

			CALL SetListDword (SHIPLIST.CARDNUMBERPblock.PblockTopOff,CURRENTSHIPLISTITEM,CURRENTSHIPPICKCARD)
			' SHIP PICK CARD NUMBER

			GOSUB MAKESPACES

			CALL SetListString (SHIPLIST.SHIPPICKLISTPblock.PblockTopOff,CURRENTSHIPLISTITEM,MID$(SHIPPICK.PRODUCT, 1, AsciizLength(SHIPPICK.PRODUCT)) +MID$(SPACES, 1, AsciizLength(SPACES)) +MID$(SHIPPICK.CUSTID, 1, AsciizLength(SHIPPICK.CUSTID)) +MID$(SPACES2, 1, AsciizLength(SPACES2)) +MID$(SHIPPICK.CONTROL, 1, AsciizLength(SHIPPICK.CONTROL)) +MID$(SPACES3, 1, AsciizLength(SPACES3)) +MID$(SHIPPICK.LOCATION, 1, AsciizLength(SHIPPICK.LOCATION))  + CHR$(0))

			CURRENTSHIPLISTITEM = CURRENTSHIPLISTITEM+1
			' INCREASE LIST ITEM NUMBER

		END IF

		CALL do.clear.card (VARSEG (SHIPPICK), VARPTR (SHIPPICK))

		CALL move.file.ptr (DummyVariable&, CURRENTSHIPPICKCARD, VARSEG (SHIPPINGPICK), VARPTR (SHIPPINGPICK), 1)

	WEND

	CALL get.byte.parameters (0, 12, 12, -20, 1, 20, 78)
	CALL set.relative.origin (DboxSrow, DboxScol, DboxWidth, DboxHeight)
	CALL set.refresh.mode (0)
	CALL open.window (DboxSrow, DboxScol, DboxErow, DboxEcol)
	CALL name.window (DboxSrow, DboxScol, DboxErow, DboxEcol, text.string3$, 0)
	'  LIST OF PRODUCTS TO SHIP 

	CALL get.byte.parameters (2, 0, 0, 4, 3, 4, 3)
	CALL SetCardOrig (VARSEG (SHIPLIST), VARPTR (SHIPLIST), DboxSrow*&H100 + DboxScol)
	CALL get.card.input (1, 0, 0, VARSEG (SHIPLIST), VARPTR (SHIPLIST), VARSEG (DummyHandle), VARPTR (DummyHandle), VARSEG (LISTBUTTON), VARPTR (LISTBUTTON))

	CALL reset.relative.origin
	CALL get.byte.parameters (0, 12, 12, -20, 1, 20, 78)
	CALL set.refresh.mode (0)
	CALL close.window (DboxSrow, DboxScol, DboxErow, DboxEcol)
	'  LIST OF PRODUCTS TO SHIP 

	IF (LISTBUTTON.ObjectType = CHR$(1)) AND (LISTBUTTON.ObjectData1 = &H0050) AND (UCASE$(LISTBUTTON.CardName) = UCASE$(SHIPLIST.LayCardHeaderStructure.CardName)) THEN

		CALL get.current.item (VARSEG (SHIPLIST.SHIPPICKLISTPblock.PblockTopOff), VARPTR (SHIPLIST.SHIPPICKLISTPblock.PblockTopOff), CHOSENLISTITEM, TOTALLISTITEMS)

		CARDTOMOVETO = GetListDword&(SHIPLIST.CARDNUMBERPblock.PblockTopOff,CHOSENLISTITEM)

		CALL move.file.ptr (CARDTOMOVETO, CURRENTSHIPPICKCARD, VARSEG (SHIPPINGPICK), VARPTR (SHIPPINGPICK), 5)

		CALL get.current.card (VARSEG (SHIPPINGPICK), VARPTR (SHIPPINGPICK), OPENPICKRESULT)

		CALL get.byte.parameters (0, 12, 12, -20, 1, 20, 77)
		CALL set.relative.origin (DboxSrow, DboxScol, DboxWidth, DboxHeight)
		CALL set.refresh.mode (0)
		CALL open.window (DboxSrow, DboxScol, DboxErow, DboxEcol)
		CALL name.window (DboxSrow, DboxScol, DboxErow, DboxEcol, text.string4$, 0)
		'  CHOSEN SHIP PICK CARD 

		CALL get.byte.parameters (2, 0, 0, 9, 9, 9, 9)
		CALL SetCardOrig (VARSEG (SHIPPICK), VARPTR (SHIPPICK), DboxSrow*&H100 + DboxScol)
		CALL get.card.input (1, 0, 0, VARSEG (SHIPPICK), VARPTR (SHIPPICK), VARSEG (DummyHandle), VARPTR (DummyHandle), VARSEG (LISTBUTTON), VARPTR (LISTBUTTON))

		CALL reset.relative.origin
		CALL get.byte.parameters (0, 12, 12, -20, 1, 20, 77)
		CALL set.refresh.mode (0)
		CALL close.window (DboxSrow, DboxScol, DboxErow, DboxEcol)
		'  CHOSEN SHIP PICK CARD 

		CALL replace.card (VARSEG (SHIPPINGPICK), VARPTR (SHIPPINGPICK), CLOSESHIPPICK)

		CALL get.card.link (VARSEG (SHIPPICK.SHIPPINGLINK), VARPTR (SHIPPICK.SHIPPINGLINK), shipcardid, filename)
		' commen

	END IF


RETURN


MAKESPACES:

	GOSUB SPACES1

	GOSUB SPACES2

	GOSUB SPACES3

	GOSUB SPACES4


RETURN


SPACES1:

	SPACES = " " + CHR$(0)	' SPACES

	CALL GETTEXTOBJECTLENGTH (SHIPPICK.PRODUCT, lengthoftextobject, 3)
	' PRODUCT NAME

	lengthofotherobject = 1

	WHILE lengthoftextobject+lengthofotherobject <= 20

	' 20

		SPACES = MID$(SPACES, 1, AsciizLength(SPACES)) +" " + CHR$(0)		' INCREASE SPACES

		CALL GETTEXTOBJECTLENGTH (SPACES, lengthofotherobject, 3)
		' spaces2

	WEND


RETURN


SPACES2:

	SPACES2 = " " + CHR$(0)	' SPACES2

	CALL GETTEXTOBJECTLENGTH (SHIPPICK.CUSTID, lengthoftextobject, 3)
	' QTY LENGTH

	lengthofotherobject = 1

	WHILE lengthoftextobject+lengthofotherobject <= 15

	' 10

		SPACES2 = MID$(SPACES2, 1, AsciizLength(SPACES2)) +" " + CHR$(0)		' INCREASE SPACES

		CALL GETTEXTOBJECTLENGTH (SPACES2, lengthofotherobject, 3)
		' spaces3

	WEND


RETURN


SPACES3:

	SPACES3 = " " + CHR$(0)	' SPACES3

	CALL GETTEXTOBJECTLENGTH (SHIPPICK.CONTROL, lengthoftextobject, 3)
	' QTY LENGTH

	lengthofotherobject = 1

	WHILE lengthoftextobject+lengthofotherobject <= 19

	' 10

		SPACES3 = MID$(SPACES3, 1, AsciizLength(SPACES3)) +" " + CHR$(0)		' INCREASE SPACES

		CALL GETTEXTOBJECTLENGTH (SPACES3, lengthofotherobject, 3)
		' spaces3

	WEND


RETURN


SPACES4:


RETURN


SEARCHFORPO:

	CALL goto.cardfile.ID (shipcardid, CURRENTSHIPCARD, VARSEG (SHIPINPUT), VARPTR (SHIPINPUT), 6)
	' FIRST SHIP CARD

	CALL get.current.card (VARSEG (SHIPINPUT), VARPTR (SHIPINPUT), OPENSHIPRESULT)
	' SHIP

	CALL get.byte.parameters (0, 12, 12, -20, 2, 20, 77)
	CALL set.relative.origin (DboxSrow, DboxScol, DboxWidth, DboxHeight)
	CALL set.refresh.mode (0)
	CALL open.window (DboxSrow, DboxScol, DboxErow, DboxEcol)
	CALL name.window (DboxSrow, DboxScol, DboxErow, DboxEcol, text.string5$, 0)
	'  SHIP CARD FOR CUSTOMER 

	CALL get.byte.parameters (2, 0, 0, 5, 1, 5, 1)
	CALL SetCardOrig (VARSEG (SHIPCARD), VARPTR (SHIPCARD), DboxSrow*&H100 + DboxScol)
	CALL get.card.input (1, 0, 0, VARSEG (SHIPCARD), VARPTR (SHIPCARD), VARSEG (DummyHandle), VARPTR (DummyHandle), VARSEG (GOONBUTTON), VARPTR (GOONBUTTON))

	CALL reset.relative.origin
	CALL get.byte.parameters (0, 12, 12, -20, 2, 20, 77)
	CALL set.refresh.mode (0)
	CALL close.window (DboxSrow, DboxScol, DboxErow, DboxEcol)
	'  SHIP CARD FOR CUSTOMER 

	IF (GOONBUTTON.ObjectType = CHR$(1)) AND (GOONBUTTON.ObjectData1 = &H0290) AND (UCASE$(GOONBUTTON.CardName) = UCASE$(SHIPCARD.LayCardHeaderStructure.CardName)) THEN

		CALL replace.card (VARSEG (SHIPINPUT), VARPTR (SHIPINPUT), CLOSESHIPPICK)

		IF SHIPCARD.SHIPPEDQTY = SHIPCARD.QTY THEN
		' ship qtys match

		END IF

		CALL delete.card (VARSEG (SHIPPINGPICK), VARPTR (SHIPPINGPICK), OPENSHIPPICK)
		' delete shippick card

	END IF


RETURN



END SUB


