' $DYNAMIC

IF SBFOpen (image.file.name$) <> -1 THEN GOTO INITIALIZE.LAYOUT.DATA
END
INITIALIZE.LAYOUT.DATA:

' ---------------------- Menu Information -----------------------

MenuFlag = 0
DataMenuTitles = 0
MaxMenuWidth = 0
MaxMenuHeight = 0
MenuStructure = 0
MenuHelpTable = 0


' ---------------- Card Variables and Structures ----------------

TYPE SYSADMINStruct
	LayCardHeaderStructure AS LayoutCardHeaderStruct
	EMPLOYEEIDStruct AS LayoutCardDescStruct
	PASSWORDStruct AS LayoutCardDescStruct
	INVENTORYStruct AS LayoutCardDescStruct
	WAREHOUSEStruct AS LayoutCardDescStruct
	PRODUCTStruct AS LayoutCardDescStruct
	CALCULATEStruct AS LayoutCardDescStruct
	ORDERENTRYStruct AS LayoutCardDescStruct
	MASTSCHEDULEStruct AS LayoutCardDescStruct
	ACTIVATEStruct AS LayoutCardDescStruct
	REPORTSStruct AS LayoutCardDescStruct
	TOOLSStruct AS LayoutCardDescStruct
	QUITStruct AS LayoutCardDescStruct
	CONTINUEStruct AS LayoutCardDescStruct
	CANCELStruct AS LayoutCardDescStruct
	PROGRAMStruct AS LayoutCardDescStruct
	LeftArrowStruct AS LayoutCardDescStruct
	RightArrowStruct AS LayoutCardDescStruct
	CardCondData AS STRING*2
	CardBackData AS STRING*906
	EMPLOYEEID AS STRING*12
	PASSWORD AS STRING*12
	INVENTORY AS STRING*1
	CALCULATE AS STRING*1
	WAREHOUSE AS STRING*1
	PRODUCT AS STRING*1
	ORDERENTRY AS STRING*1
	MASTSCHEDULE AS STRING*1
	ACTIVATE AS STRING*1
	REPORTS AS STRING*1
	TOOLS AS STRING*1
	QUIT AS STRING*1
	PROGRAM AS STRING*1
END TYPE

DIM SHARED SYSADMIN AS SYSADMINStruct
	CALL SBF (varseg(SYSADMIN), varptr(SYSADMIN), 1756, &H0000000A)

TYPE SHIPPICKStruct
	LayCardHeaderStructure AS LayoutCardHeaderStruct
	PRODUCTStruct AS LayoutCardDescStruct
	CUSTIDStruct AS LayoutCardDescStruct
	CONTROLStruct AS LayoutCardDescStruct
	LOCATIONStruct AS LayoutCardDescStruct
	QTYTOSHIPStruct AS LayoutCardDescStruct
	STATUSStruct AS LayoutCardDescStruct
	CONTINUEStruct AS LayoutCardDescStruct
	CANCELStruct AS LayoutCardDescStruct
	ORDEREDQTYStruct AS LayoutCardDescStruct
	PARTIALSHIPOKStruct AS LayoutCardDescStruct
	SHIPPINGLINKStruct AS LayoutCardDescStruct
	LeftArrowStruct AS LayoutCardDescStruct
	RightArrowStruct AS LayoutCardDescStruct
	CardCondData AS STRING*2
	CardBackData AS STRING*298
	PRODUCT AS STRING*31
	CUSTID AS STRING*15
	CONTROL AS STRING*15
	LOCATION AS STRING*15
	QTYTOSHIP AS DOUBLE
	ORDEREDQTY AS DOUBLE
	STATUS AS STRING*1
	PARTIALSHIPOK AS STRING*1
	SHIPPINGLINK AS STRING*88
END TYPE

DIM SHARED SHIPPICK AS SHIPPICKStruct
	CALL SBF (varseg(SHIPPICK), varptr(SHIPPICK), 956, &H000006E6)

TYPE SHIPCARDStruct
	LayCardHeaderStructure AS LayoutCardHeaderStruct
	SHIPNAMEStruct AS LayoutCardDescStruct
	SHIPADDRESSStruct AS LayoutCardDescStruct
	SHIPCOMPANYStruct AS LayoutCardDescStruct
	SHIPCITYStruct AS LayoutCardDescStruct
	SHIPSTATEStruct AS LayoutCardDescStruct
	SHIPZIPStruct AS LayoutCardDescStruct
	SHIPAUTHORIZEDStruct AS LayoutCardDescStruct
	SHIPHOWPAYStruct AS LayoutCardDescStruct
	SHIPPOStruct AS LayoutCardDescStruct
	SHIPMMStruct AS LayoutCardDescStruct
	SHIPDAYStruct AS LayoutCardDescStruct
	SHIPYEARStruct AS LayoutCardDescStruct
	SHIPCLIENTStruct AS LayoutCardDescStruct
	CONTINUEStruct AS LayoutCardDescStruct
	CANCELStruct AS LayoutCardDescStruct
	PRODUCTNAMEStruct AS LayoutCardDescStruct
	QTYStruct AS LayoutCardDescStruct
	SHIPBYStruct AS LayoutCardDescStruct
	CUSTOMERIDStruct AS LayoutCardDescStruct
	SHIPTYPEStruct AS LayoutCardDescStruct
	PRODUCTSHIPPEDStruct AS LayoutCardDescStruct
	SHIPPEDQTYStruct AS LayoutCardDescStruct
	LeftArrowStruct AS LayoutCardDescStruct
	RightArrowStruct AS LayoutCardDescStruct
	CardCondData AS STRING*2
	CardBackData AS STRING*1931
	SHIPNAME AS STRING*30
	SHIPADDRESS AS STRING*34
	SHIPCOMPANY AS STRING*30
	SHIPCITY AS STRING*22
	SHIPSTATE AS STRING*5
	SHIPZIP AS STRING*13
	SHIPAUTHORIZED AS STRING*10
	SHIPBY AS STRING*21
	SHIPMM AS INTEGER
	SHIPDAY AS INTEGER
	SHIPYEAR AS INTEGER
	PRODUCTNAME AS STRING*32
	SHIPPO AS STRING*26
	CUSTOMERID AS STRING*21
	SHIPHOWPAY AS STRING*1
	QTY AS DOUBLE
	SHIPTYPE AS STRING*1
	SHIPCLIENT AS STRING*88
	PRODUCTSHIPPED AS STRING*32
	SHIPPEDQTY AS DOUBLE
END TYPE

DIM SHARED SHIPCARD AS SHIPCARDStruct
	CALL SBF (varseg(SHIPCARD), varptr(SHIPCARD), 3117, &H00000AA2)

TYPE sortlistStruct
	LayCardHeaderStructure AS LayoutCardHeaderStruct
	sortlistStruct AS LayoutCardDescStruct
	CardCondData AS STRING*2
	sortlistPblock AS LayoutCardPblockStruct
	sortlist AS STRING*320
END TYPE

DIM SHARED sortlist AS sortlistStruct
	CALL SBF (varseg(sortlist), varptr(sortlist), 82, &H000016CF)

TYPE SHIPLISTStruct
	LayCardHeaderStructure AS LayoutCardHeaderStruct
	SHIPPICKLISTStruct AS LayoutCardDescStruct
	CONTINUEStruct AS LayoutCardDescStruct
	CANCELStruct AS LayoutCardDescStruct
	CARDNUMBERStruct AS LayoutCardDescStruct
	CardCondData AS STRING*2
	CardBackData AS STRING*105
	SHIPPICKLISTPblock AS LayoutCardPblockStruct
	SHIPPICKLIST AS STRING*29200
	CARDNUMBERPblock AS LayoutCardPblockStruct
	CARDNUMBER AS STRING*1600
END TYPE

DIM SHARED SHIPLIST AS SHIPLISTStruct
	CALL SBF (varseg(SHIPLIST), varptr(SHIPLIST), 331, &H00001721)



CALL SBFClose


	text.string1$ = "hldsecr.crd" + CHR$(0)
	text.string2$ = "SHIPPING.CRD" + CHR$(0)
	text.string3$ = "SHIPPICK.CRD" + CHR$(0)
	text.string4$ = " LIST OF PRODUCTS TO SHIP " + CHR$(0)
	text.string5$ = " CHOSEN SHIP PICK CARD " + CHR$(0)
	text.string6$ = " SHIP CARD FOR CUSTOMER " + CHR$(0)
